-------------------------------------------------------------------------------
-- ElvUI Chat Tweaks By Lockslap (US, Bleeding Hollow)
-- <Borderline Amazing>, http://ba-guild.com
-- Based on functionality provided by Prat and/or Chatter
-------------------------------------------------------------------------------
local Module	= ElvUI_ChatTweaks:NewModule("Loot Icons")
local L			= LibStub("AceLocale-3.0"):GetLocale("ElvUI_ChatTweaks")
Module.name		= L["Loot Icons"]

local db, options
local defaults = {
	profile = {
		orientation	= "left",
	}
}

local function AddLootIcons(self, event, message, ...)
	local _, fontSize = GetChatWindowInfo(self:GetID())
	local function IconForLink(link)
		local texture = GetItemIcon(link)
		return (db.orientation == "left") and "\124T" .. texture .. ":" .. fontSize .. "\124t" .. link or link .. "\124T" .. texture .. ":" .. fontSize .. "\124t"
	end
	message = message:gsub("(\124c%x+\124Hitem:.-\124h\124r)", IconForLink)
	return false, message, ...
end

function Module:OnEnable()
	ChatFrame_AddMessageEventFilter("CHAT_MSG_LOOT", AddLootIcons)
end

function Module:OnDisable()
	ChatFrame_RemoveMessageEventFilter("CHAT_MSG_LOOT", AddLootIcons)
end

function Module:OnInitialize()
	self.db = ElvUI_ChatTweaks.db:RegisterNamespace("LootIcons", defaults)
	db = self.db.profile
end

function Module:GetOptions()
	if not options then
		options = {
			orientation = {
				type	= "select",
				order	= 13,
				name	= L["Icon Orientation"],
				desc	= L["Icon to the left or right of the item link."],
				values	= {
					["left"]	= L["Left"],
					["right"]	= L["Right"],
				},
				get		= function() return db.orientation end,
				set		= function(_, value) db.orientation = value end,
			}
		}
	end
	return options
end

function Module:Info()
	return L["Add item icons to loot received messages."]
end